#####################################################################
#####################################################################
#####################################################################
#
# ndisplay.pl file for plushpuffin's perl garden
#
# plushpuffin@wwddfd.com
# http://www.wwddfd.com
#
#
#####################################################################
#####################################################################
#####################################################################
#
#
# ndisplay.pl
# This file contains the HTML used to generate your news.
#
# For more information on NewsPro customisations, see the online FAQ.
#
# Do not change $ndisplayversion below! It tells the script which version of ndisplay.pl this is.
$ndisplayversion = 3;
#
# *********
# IMPORTANT: If you ever edit this file by hand, remove the exclamation mark
# *********  from the next line:
# <ManualEdit>
# (do not remove the # or anything else, only the exclamation mark)
# This will tell the script that it has been edited by hand, and disable web-based
# editing. If you don't do this, your ndisplay.pl will likely become corrupted.
#
# You may use the following variables in DoNewsHTML:
# $newsname, $newssubject, $newsdate, $newstext, $newsemail.
# Also, remember that this is a Perl script you're editing. Make sure to escape necessary
# characters: i.e. $,@,%,and ~ should be written as \$,\@,\%, and \~ (of course, you 
# shouldn't escape the $ sign in a variable).

#####################################################################
#####################################################################
#####################################################################
#
# NewsCatSortOrdinal
#
#####################################################################
#
# Sort by the ordinal field and then by news subject
#
# perform a normal NewsCatFilter first to remove news from the
# wrong categories and older news.
#
#####################################################################
#
sub NewsCatSortOrdinal {
	my @NND = &NewsCatFilter(@_);
	my @NNDsorted = map { $_->[0] }
		sort { $b->[1] <=> $a->[1] || $b->[2] cmp $a->[2] }
		map { [ $_, $_->{'ordinal'}, $_->{'newssubject'} ] } @NND;
	return @NNDsorted;
}


#####################################################################
#####################################################################
#####################################################################
#
# NewsCatFilterOrdinal
#
#####################################################################
#
# filter out news which is greater than 'ordinal' days old + max age in days
#
# used on the welcome page (the news page) to allow for dynamic
# individual expiration of news posts.
#
#####################################################################
#
sub NewsCatFilterOrdinal {
	my $mintime = pop;
	$mintime = $mintime * 86400;
	my @filtcats = @_;
	my %filtcats;
	my $nd;
	undef @NewNewsData;
	my @NewNewsData;
	foreach $i (@filtcats) {
		unless ($i eq '(default)') {
			$filtcats{$i} = 1;
		}
		else {
			$filtcats{''} = 1;
		}
	}
	foreach $nd (@NewsData) {
		# First, check if it matches the category.
		if ($filtcats{$nd->{'newscat'}} || $filtcats{'AllCategories'}) {
			# It matches. Now check the time.
			if ($nd->{'newstime'} + ( $nd->{'ordinal'} * 86400 ) >= (time - $mintime)) {
				# It's good. Add to the new array.
				push(@NewNewsData, $nd);
			}
		}
	}
	return @NewNewsData;
}


#####################################################################
#####################################################################
#####################################################################
#
# DoStaticAddonHTML
#
#####################################################################
#
# static page subroutine
#
# used to generate a static page for each addon's description
# kind of boring, but shows the UserGroups ICQ property in action!
#
#####################################################################
#
sub DoStaticAddonHTML {
	$authorICQ = $UGP_ICQ ? qq~<img src="http://online.mirabilis.com/scripts/online.dll?icq=$UGP_ICQ&img=5" alt="$UGP_ICQ">~ : q~<img src="http://www.icq.com/images/status/disabled-5.gif" width=18 height=18 border=0 alt="icq disabled">~;
	$authorEMAIL = $newsemail ? qq~<a href="mailto:$newsemail">$newsauthor</a>~ : qq~<b>$newsauthor</b>~;
	$fileHREF = $newshref ? qq~<br><center><a href="/$profile_title/dm.cgi?action=link&file=http://www.wwddfd.com/$profile_title/$newshref"><img src="/gfx/kitty.gif" width="32" height="32"></a></center>~ : '';
	$newshtml = qq~
<div class="bigtitle"><B>$newssubject</B></div><br>
<center>version $ordinal<br>
by $authorEMAIL$authorICQ</center><br>
$summary<br>
<HR width="75%" align="center">
<div align="left">$newstext</div><br>
<br><div align="right" class="smalltype"><font size="-1" color="#222222">posted by $newsname ($newsdate)</font></div><br>
$fileHREF
~;	
}


#####################################################################
#####################################################################
#####################################################################
#
# DoBarHTML
#
#####################################################################
#
# generates the button sidebar for the perl garden
#
# the button sidebar is included in every page using SSI
#
#####################################################################
#
sub DoBarHTML {
	$newshtml = qq~
<tr height="42"><td align="center" valign="middle">
<a href="$newshref" title="$summary"><font size="+3" color="#00aa55" class="sectionlink">$newssubject</font></a>
</td></tr>
~;
}


#####################################################################
#####################################################################
#####################################################################
#
# DoItemListHTML
#
#####################################################################
#
# generates a list of items
#
# used to generate the addon index page with links to static pages
#
# the $LinkURL property is a new feature of NewsCat ][ build 8 beta 1
# It will not work with earlier versions of NewsCat ][
#
# this subroutine is very boring - nothing special happening here.
#
#####################################################################
#
sub DoItemListHTML {
	$newshtml = qq~
	<table border="0" cellspacing="0" cellpadding="0" width="100%" align="center">
<tr>
	<td width="50"><img src="/gfx/rc2.gif" alt=""></td>
	<td width="100%" background="/gfx/rc12a.gif" nowrap><font size="+3" color="#00aa55" class="sectionlink"><a href="$LinkURL">$newssubject</a></font></td>
	<td width="50"><img src="/gfx/rc1.gif" alt=""></td>
</tr>
<tr>
	<td width="50" background="/gfx/rc23.gif"><img src="/gfx/rc23.gif" alt=""></td>
	<td width="100%" valign="top" bgcolor="#e2f6cd" class="story">
		$summary
		<div align="right" class="signed">by $newsauthor</div>
	</td>
	<td width="50" background="/gfx/rc14.gif" valign="top"><img src="/gfx/rc14a.gif" alt=""></td>
</tr>
<tr>
	<td width="50"><img src="/gfx/rc3.gif" alt=""></td>
	<td width="100%" background="/gfx/rc34.gif"><div align="left"><img src="/gfx/rc34a.gif" alt=""></div></td>
	<td width="50"><img src="/gfx/rc4.gif" alt=""></td>
</tr>
</table>
~;
}


#####################################################################
#####################################################################
#####################################################################
#
# DoWelcomeHTML
#
#####################################################################
#
# the welcome page, otherwise known as the news page
#
# generates a table for each day with separator GIFs in between each
# news item for the day. a little complicated but it works...
#
# the table is a 3x3 table with the outer cells being the
# fancy GIF-background border.
#
# the GIF images named "rcX.gif" are the corners.
# the GIF images named "rcXY.gif" are the sides between the corners.
#
# rc2.gif		rc12.gif		rc1.gif
# rc23.gif		content		rc14.gif
# rc3.gif		rc34.gif		rc4.gif
#
# this is actually slightly more complicated than the above
# table describes, since there are GIFs named rcXYa.gif which
# have a gradient for gradual blending between the different
# corner highlight colors.
#
# check out http://www.wwddfd.com to see what I mean.
#
#####################################################################
#
sub DoWelcomeHTML {
	$authorEMAIL = $newsemail ? qq~<a href="mailto:$newsemail">$newsauthor</a>~ : qq~<b>$newsauthor</b>~;
	$wwthisday = "$Day$Month$Year";
	$wwdaydiff = ( $wwthisday ne $wwlastday );
	$newshtml = '';
	if( $wwdaydiff && $wwlastday ne '' ) {
		$newshtml .= qq~
	</td>
	<td width="50" background="/gfx/rc14.gif" valign="top"><img src="/gfx/rc14a.gif" alt=""></td>
</tr>
<tr>
	<td width="50"><img src="/gfx/rc3.gif" alt=""></td>
	<td width="100%" background="/gfx/rc34.gif"><div align="left"><img src="/gfx/rc34a.gif" alt=""></div></td>
	<td width="50"><img src="/gfx/rc4.gif" alt=""></td>
</tr>
</table><br>
~;
	}
	if( $wwdaydiff ) {
		$newshtml .= qq~
<table border="0" cellspacing="0" cellpadding="0" width="100%" align="center">
<tr>
	<td width="50"><img src="/gfx/rc2.gif" alt=""></td>
	<td width="100%" background="/gfx/rc12.gif" valign="middle"><div align="center" class="timestamp">$Weekday, $Month_Name $Day, $Year</div></td>
	<td width="50"><img src="/gfx/rc1.gif" alt=""></td>
</tr>
<tr>
	<td width="50" background="/gfx/rc23.gif"><img src="/gfx/rc23.gif" alt=""></td>
	<td width="100%" valign="top" bgcolor="#e2f6cd" class="story">
~;
	}
	else {
		$newshtml .= q~<center><img src="/gfx/sepwave.gif" alt=""></center>~;
	}
	$newshtml .= qq~
<div class="bigtitle"><B>$newssubject</B></div><br>
<HR width="75%" align="center">
<div class="timestamp">$Hour:$Minute:$Second</div><br>
<div class="story">$newstext</div><br>
<div class="signed" align="left">-- $authorEMAIL</div>
~;
	unless( $newsnum ) {
		$newshtml .= qq~
	</td>
	<td width="50" background="/gfx/rc14.gif" valign="top"><img src="/gfx/rc14a.gif" alt=""></td>
</tr>
<tr>
	<td width="50"><img src="/gfx/rc3.gif" alt=""></td>
	<td width="100%" background="/gfx/rc34.gif"><div align="left"><img src="/gfx/rc34a.gif" alt=""></div></td>
	<td width="50"><img src="/gfx/rc4.gif" alt=""></td>
</tr>
</table><br>
~;
	}
	$wwlastday = $newsnum ? $wwthisday : '';
}


#####################################################################
#####################################################################
#####################################################################
#
#
# everything past this point is unchanged.
#
#
#####################################################################
#####################################################################
#####################################################################


sub DoNewsHTML {
# <BeginEdit>
$newshtml = qq~

<p><strong><font color="#ff0000">$newssubject</font> </strong><small>Posted $newsdate by <a href="mailto:$newsemail">$newsname</a></small><br>
$newstext
</p>

~;
# <EndEdit>
}


#
# Archive Link Formatting. Edit the HTML below to change the style.
# This defines the links on the main archive page, the one that
# links to the individual monthly archives.
# The location of the archive is $arcfile.$ArcHtmlExt and the 
# month the archive covers is $ArcDate{$arcfile}.
# Reminder: if editing this file by hand, follow the instructions
# at the top of the file or the script may not function.
sub DoLinkHTML {
	$newshtml = qq~
<a href="$arcfile.$ArcHtmlExt">$ArcDate{$arcfile}</a><br>
~;
}

#
# Headline Formatting.
# This defines the headlines that will be produced if you enable headlines
# (in Advanced Settings).
# You have access to all the variables as in DoNewsHTML.
# TIP: To link the headline to your full news article, use a link like:
# <a href="http://my.site/mynewspage.html#newsitem$newsid">$newssubject</a>
sub DoHeadlineHTML {
	$newshtml = qq~
<b>$newssubject</b> - $newsdate <br>
~;
}

#
#
# New Files Formatting
# The format of the file links on the new files list (enabled via Advanced Settings).
# $fileurl: URL of the file
# $filetitle: Name or title of the file
# $filedate: Date the file was last modified
sub DoNewFileHTML {
	$newshtml = qq~
<a href="$fileurl">$filetitle</a><br>
~;
}

# Email Notification
# How the e-mail notifications sent will look.
# If you choose to have news items sent manually, in batches,
# you'll be able to edit this before sending. Otherwise, this will be
# the text of the message.
#
# You have access to all the new variables, as in DoNewsHTML.
sub DoEmailText {
	$newshtml = qq~
---------------------------------
$newssubject
---------------------------------
Posted $newsdate by $newsname:
$newstext
~;
}

# Archive HTML
# The news style used when archiving.
# By default, calls DoNewsHTML. If you'd like a different style, replace this with something like
# sub DoArchiveHTML {
# $newshtml = qq~
# <p><strong><font color="#ff0000">$newssubject</font> </strong><small>Posted $newsdate by <a href="mailto:$newsemail">$newsname</a></small><br>
# $newstext
# </p>
# ~;
# }
sub DoArchiveHTML {
&DoNewsHTML;
}
# Search HTML
# Much like archive HTML - by default, uses DoNewsHTML.
sub DoSearchHTML {
&DoNewsHTML;
}

1;
